/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and others contributors as indicated 
 * by the @authors tag. All rights reserved. 
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors. 
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
package org.jboss.soa.esb.test;

import java.util.Properties;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.jms.Connection;
import javax.jms.ConnectionMetaData;

public class TEST_SOA547 {
    QueueConnection conn;
    Queue que;
    
    public void setupConnection() throws JMSException, NamingException
    {
        Properties properties1 = new Properties();
		properties1.put(Context.INITIAL_CONTEXT_FACTORY,
				"org.jnp.interfaces.NamingContextFactory");
		properties1.put(Context.URL_PKG_PREFIXES,
				"org.jboss.naming:org.jnp.interfaces");
		properties1.put(Context.PROVIDER_URL, "jnp://127.0.0.1:1099");
		InitialContext iniCtx = new InitialContext(properties1);

    	Object tmp = iniCtx.lookup("ConnectionFactory");
    	QueueConnectionFactory qcf = (QueueConnectionFactory) tmp;
    	conn = qcf.createQueueConnection();

	ConnectionMetaData meta = conn.getMetaData();	      
	System.out.println("meta.getJMSMajorVersion()--> " + meta.getJMSMajorVersion());
	System.out.println("meta.getJMSMinorVersion()--> " + meta.getJMSMinorVersion());
	System.out.println("meta.getJMSProviderName()--> " + meta.getJMSProviderName());
	System.out.println("meta.getJMSVersion()--> " + meta.getJMSVersion());
	System.out.println("meta.getProviderMajorVersion()--> " + meta.getProviderMajorVersion());
	System.out.println("meta.getProviderMinorVersion()--> " + meta.getProviderMinorVersion());
	System.out.println("meta.getProviderVersion()--> " + meta.getProviderVersion());
	for (java.util.Enumeration e = meta.getJMSXPropertyNames() ; e.hasMoreElements() ;) {
        	System.out.println("meta.getJMSXPropertyNames()-->" + e.nextElement());
	}
    }
    
    public void stop() throws JMSException 
    { 
        conn.stop();
        conn.close();
    }       
    
    public static void main(String args[]) throws Exception
    {        	    	
    	TEST_SOA547 sm = new TEST_SOA547();
	sm.setupConnection();
    	sm.stop();    	
    }
    
}
